//
// Official Solution
// Author: Jongseo Lee (@leejseo)
//
#include <stdio.h>
#include <string.h>
 
const int UNDEF = -1;
 
char *ANS[] = {
    "Second",
    "First",
};
 
int N, M, K, Q;
int D[301][301];
char blocked[301][301];
 
int valid(int i, int j)
{
    return 0 <= i && i < N && 0 <= j && j < M && blocked[i][j] == '.';
}
 
int solve(int i, int j)
{
    if (D[i][j] != UNDEF)
    {
        return D[i][j];
    }
    if (valid(i + 1, j) && !solve(i + 1, j))
    {
        return D[i][j] = 1;
    }
    if (valid(i, j + 1) && !solve(i, j + 1))
    {
        return D[i][j] = 1;
    }
    for (int k = 1; k <= K; k++)
    {
        if (valid(i + k, j + k) && !solve(i + k, j + k))
        {
            return D[i][j] = 1;
        }
    }
    return D[i][j] = 0;
}
 
int main(void)
{
    memset(D, UNDEF, sizeof(D));
    scanf("%d", &N);
    scanf("%d", &M);
    scanf("%d", &K);
    for (int i = 0; i < N; i++)
    {
        scanf("%s", blocked[i]);
    }
    scanf("%d", &Q);
    while (Q--)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        printf("%s\n", ANS[solve(--x, --y)]);
    }
    return 0;
}
