//
// Official Solution
// Author: Jongseo Lee (@leejseo)
//
 
import java.util.Arrays;
import java.util.Scanner;
 
public class Main {
    static final int UNDEF = -1;
 
    static String[] ANS = {
        "Second",
        "First"
    };
 
    static int N, M, K, Q;
    static int[][] D;
    static char[][] blocked;
 
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        N = scanner.nextInt();
        M = scanner.nextInt();
        K = scanner.nextInt();
 
        D = new int[301][301];
        for (int i = 0; i <= N; i++) {
            Arrays.fill(D[i], UNDEF);
        }
 
        blocked = new char[301][301];
        for (int i = 0; i < N; i++) {
            blocked[i] = scanner.next().toCharArray();
        }
 
        Q = scanner.nextInt();
        while (Q-- > 0) {
            int x = scanner.nextInt();
            int y = scanner.nextInt();
            System.out.println(ANS[solve(--x, --y)]);
        }
    }
 
    static boolean valid(int i, int j) {
        return 0 <= i && i < N && 0 <= j && j < M && blocked[i][j] == '.';
    }
 
    static int solve(int i, int j) {
        if (D[i][j] != UNDEF) {
            return D[i][j];
        }
 
        if (valid(i + 1, j) && solve(i + 1, j) == 0) {
            return D[i][j] = 1;
        }
 
        if (valid(i, j + 1) && solve(i, j + 1) == 0) {
            return D[i][j] = 1;
        }
 
        for (int k = 1; k <= K; k++) {
            if (valid(i + k, j + k) && solve(i + k, j + k) == 0) {
                return D[i][j] = 1;
            }
        }
 
        return D[i][j] = 0;
    }
}
