#
# Official Solution
# Author: Jongseo Lee (@leejseo)
#

N, M, K = map(int, input().split())
X = [input() for _ in range(N)]

D = [[None] * M for _ in range(N)]
D[N - 1][M - 1] = False


def allowed(i, j):
    # returns True iff (i, j) is in the board and
    # (i, j) is not a forbidden cell
    return 0 <= i < N and 0 <= j < M and X[i][j] == '.'


def dp(i, j):
    # returns True iff the player starting from (i, j) is able to win the game
    if D[i][j] is not None:
        return D[i][j]
    if allowed(i + 1, j) and not dp(i + 1, j):
        D[i][j] = True
        return True
    if allowed(i, j + 1) and not dp(i, j + 1):
        D[i][j] = True
        return True
    for k in range(1, K + 1):
        if allowed(i + k, j + k) and not dp(i + k, j + k):
            D[i][j] = True
            return True
    D[i][j] = False
    return False


Q = int(input())
for _ in range(Q):
    i, j = map(int, input().split())
    if dp(i - 1, j - 1):
        print("First")
    else:
        print("Second")
